diff --git a/jit/jit-rules-x86-64.ins b/jit/jit-rules-x86-64.ins
index f8a1096..df23dc0 100644
--- a/jit/jit-rules-x86-64.ins
+++ b/jit/jit-rules-x86-64.ins
@@ -499,8 +499,13 @@ JIT_OP_SET_PARAM_NFLOAT: note
 			x86_64_fstp_membase_size(inst, X86_64_RSP, $2, 8);
 		}
 	}
-
+  
 JIT_OP_SET_PARAM_STRUCT: note
+	[reg, imm, scratch reg, scratch xreg,
+		if("$2 <= _JIT_MAX_MEMCPY_INLINE")] -> {
+		jit_nint offset = jit_value_get_nint_constant(insn->dest);
+		inst = small_block_copy(gen, inst, X86_64_RSP, offset, $1, 0, $2, $3, $4, 1);
+	}
 	[reg, imm, clobber(creg), clobber(xreg)] -> {
 		/* Handle arbitrary-sized structures */
 		jit_nint offset = jit_value_get_nint_constant(insn->dest);
@@ -508,7 +513,7 @@ JIT_OP_SET_PARAM_STRUCT: note
 		inst = memory_copy(gen, inst, X86_64_RSP, offset, $1, 0, $2);
 	}
 
-
+  
 /*
  * Opcodes to handle return values
  */
@@ -3000,7 +3005,9 @@ JIT_OP_CALL_TAIL:
 
 JIT_OP_CALL_INDIRECT:
 	[] -> {
+#ifndef WIN64
 		x86_64_mov_reg_imm_size(inst, X86_64_RAX, 8, 4);
+#endif
 		x86_64_call_reg(inst, X86_64_SCRATCH);
 	}
 
@@ -3013,7 +3020,9 @@ JIT_OP_CALL_INDIRECT_TAIL:
 
 JIT_OP_CALL_VTABLE_PTR:
 	[] -> {
+#ifndef WIN64
 		x86_64_mov_reg_imm_size(inst, X86_64_RAX, 8, 4);
+#endif
 		x86_64_call_reg(inst, X86_64_SCRATCH);
 	}
 
@@ -3158,12 +3167,55 @@ JIT_OP_MEMCPY: ternary
 	[reg, reg, imm, clobber(creg), clobber(xreg)] -> {
 		inst = memory_copy(gen, inst, $1, 0, $2, 0, $3);
 	}
-	[reg("rdi"), reg("rsi"), reg("rdx"), clobber(creg), clobber(xreg)] -> {
+	[reg("argreg1"), reg("argreg2"), reg("argreg3"), clobber(creg), clobber(xreg)] -> {
 		inst = x86_64_call_code(inst, (jit_nint)jit_memcpy);
 	}
 
 JIT_OP_MEMSET: ternary
-	[reg("rdi"), reg("rsi"), reg("rdx"), clobber(creg), clobber(xreg)] -> {
+	[any, any, imm, if("$3 <= 0")] -> { }
+	[reg, imm, imm, scratch reg, if("$3 <= 64 && $2 == 0")] -> {
+		int disp;
+		disp = 0;
+		x86_64_xor_reg_reg_size(inst, $4, $4, 8);
+		while($3 >= (disp + 8))
+		{
+			x86_64_mov_membase_reg_size(inst, $1, disp, $4, 8);
+			disp += 8;
+		}
+		if($3 >= (disp + 4))
+		{
+			x86_64_mov_membase_reg_size(inst, $1, disp, $4, 4);
+			disp += 4;
+		}
+		if($3 >= (disp + 2))
+		{
+			x86_64_mov_membase_reg_size(inst, $1, disp, $4, 2);
+			disp += 2;
+		}
+		if(insn->value2->address > disp)
+		{
+			x86_64_mov_membase_reg_size(inst, $1, disp, $4, 1);
+		}
+	}
+	[reg, imm, imm, if("$3 <= 32")] -> {
+		int disp;
+		disp = 0;
+		while($3 >= (disp + 4))
+		{
+			x86_64_mov_membase_imm_size(inst, $1, disp, $2 * 0x01010101, 4);
+			disp += 4;
+		}
+		if($3 >= (disp + 2))
+		{
+			x86_64_mov_membase_imm_size(inst, $1, disp, $2 * 0x0101, 2);
+			disp += 2;
+		}
+		if(insn->value2->address > disp)
+		{
+			x86_64_mov_membase_imm_size(inst, $1, disp, $2, 1);
+		}
+	}
+	[reg("intarg1"), reg("intarg2"), reg("intarg3"), clobber(creg), clobber(xreg)] -> {
 		inst = x86_64_call_code(inst, (jit_nint)jit_memset);
 	}
 
diff --git a/jit/jit-rules-x86.c b/jit/jit-rules-x86.c
index 244e42a..efd3218 100644
--- a/jit/jit-rules-x86.c
+++ b/jit/jit-rules-x86.c
@@ -786,15 +786,15 @@ _jit_gen_load_value(jit_gencode_t gen, int reg, int other_reg, jit_value_t value
 			{
 				jit_float32 float32_value;
 				float32_value = jit_value_get_float32_constant(value);
-				if(IS_WORD_REG(reg))
+				union
 				{
-					union
-					{
-						jit_float32 float32_value;
-						jit_int int_value;
-					} un;
+					jit_float32 float32_value;
+					jit_int int_value;
+				} un;
+				un.float32_value = float32_value;
 
-					un.float32_value = float32_value;
+				if(IS_WORD_REG(reg))
+				{
 					x86_mov_reg_imm(inst, _jit_reg_info[reg].cpu_reg, un.int_value);
 				}
 				else
@@ -809,9 +809,9 @@ _jit_gen_load_value(jit_gencode_t gen, int reg, int other_reg, jit_value_t value
 					}
 					else
 					{
-						ptr = _jit_cache_alloc(&(gen->posn), sizeof(jit_float32));
-						jit_memcpy(ptr, &float32_value, sizeof(float32_value));
-						x86_fld(inst, ptr, 0);
+						x86_push_imm(inst, un.int_value);
+						x86_fld_membase(inst,X86_ESP,0,0);
+						x86_alu_reg_imm(inst, X86_ADD, X86_ESP, sizeof(un));
 					}
 				}
 			}
@@ -821,15 +821,16 @@ _jit_gen_load_value(jit_gencode_t gen, int reg, int other_reg, jit_value_t value
 			{
 				jit_float64 float64_value;
 				float64_value = jit_value_get_float64_constant(value);
-				if(IS_WORD_REG(reg))
+				union
 				{
-					union
-					{
-						jit_float64 float64_value;
-						jit_int int_value[2];
-					} un;
+					jit_float64 float64_value;
+					jit_int int_value[2];
+				} un;
+
+				un.float64_value = float64_value;
 
-					un.float64_value = float64_value;
+				if(IS_WORD_REG(reg))
+				{
 					x86_mov_reg_imm(inst, _jit_reg_info[reg].cpu_reg,
 							un.int_value[0]);
 					x86_mov_reg_imm(inst, _jit_reg_info[other_reg].cpu_reg,
@@ -847,9 +848,10 @@ _jit_gen_load_value(jit_gencode_t gen, int reg, int other_reg, jit_value_t value
 					}
 					else
 					{
-						ptr = _jit_cache_alloc(&(gen->posn), sizeof(jit_float64));
-						jit_memcpy(ptr, &float64_value, sizeof(float64_value));
-						x86_fld(inst, ptr, 1);
+						x86_push_imm(inst, un.int_value[1]);
+						x86_push_imm(inst, un.int_value[0]);
+						x86_fld_membase(inst,X86_ESP,0,1);
+						x86_alu_reg_imm(inst, X86_ADD, X86_ESP, sizeof(un));
 					}
 				}
 			}
@@ -859,15 +861,15 @@ _jit_gen_load_value(jit_gencode_t gen, int reg, int other_reg, jit_value_t value
 			{
 				jit_nfloat nfloat_value;
 				nfloat_value = jit_value_get_nfloat_constant(value);
-				if(IS_WORD_REG(reg) && sizeof(jit_nfloat) == sizeof(jit_float64))
+				union
 				{
-					union
-					{
-						jit_nfloat nfloat_value;
-						jit_int int_value[2];
-					} un;
+					jit_nfloat nfloat_value;
+					jit_int int_value[2];
+				} un;
+				un.nfloat_value = nfloat_value;
 
-					un.nfloat_value = nfloat_value;
+				if(IS_WORD_REG(reg) && sizeof(jit_nfloat) == sizeof(jit_float64))
+				{
 					x86_mov_reg_imm(inst, _jit_reg_info[reg].cpu_reg,
 							un.int_value[0]);
 					x86_mov_reg_imm(inst, _jit_reg_info[other_reg].cpu_reg,
@@ -885,16 +887,17 @@ _jit_gen_load_value(jit_gencode_t gen, int reg, int other_reg, jit_value_t value
 					}
 					else
 					{
-						ptr = _jit_cache_alloc(&(gen->posn), sizeof(jit_nfloat));
-						jit_memcpy(ptr, &nfloat_value, sizeof(nfloat_value));
+						x86_push_imm(inst, un.int_value[1]);
+						x86_push_imm(inst, un.int_value[0]);
 						if(sizeof(jit_nfloat) == sizeof(jit_float64))
 						{
-							x86_fld(inst, ptr, 1);
+							x86_fld_membase(inst,X86_ESP,0,1);
 						}
 						else
 						{
-							x86_fld80_mem(inst, ptr);
+							x86_fld80_membase(inst,X86_ESP,0);
 						}
+						x86_alu_reg_imm(inst, X86_ADD, X86_ESP, sizeof(un));
 					}
 				}
 			}
diff --git a/jit/jit-rules-x86.h b/jit/jit-rules-x86.h
index 464be64..fef4fa7 100644
--- a/jit/jit-rules-x86.h
+++ b/jit/jit-rules-x86.h
@@ -33,22 +33,22 @@ extern	"C" {
 #define	JIT_REG_X86_FLOAT	\
 	(JIT_REG_FLOAT32 | JIT_REG_FLOAT64 | JIT_REG_NFLOAT)
 #define	JIT_REG_INFO	\
-	{"eax", 0, 2, JIT_REG_WORD | JIT_REG_LONG | JIT_REG_CALL_USED}, \
-	{"ecx", 1, 3, JIT_REG_WORD | JIT_REG_LONG | JIT_REG_CALL_USED}, \
-	{"edx", 2, -1, JIT_REG_WORD | JIT_REG_CALL_USED}, \
-	{"ebx", 3, -1, JIT_REG_WORD | JIT_REG_GLOBAL}, \
-	{"esi", 6, -1, JIT_REG_WORD | JIT_REG_GLOBAL}, \
-	{"edi", 7, -1, JIT_REG_WORD | JIT_REG_GLOBAL}, \
-	{"ebp", 4, -1, JIT_REG_FRAME | JIT_REG_FIXED}, \
-	{"esp", 5, -1, JIT_REG_STACK_PTR | JIT_REG_FIXED | JIT_REG_CALL_USED}, \
-	{"st",  0, -1, JIT_REG_X86_FLOAT | JIT_REG_CALL_USED | JIT_REG_IN_STACK}, \
-	{"st1", 1, -1, JIT_REG_X86_FLOAT | JIT_REG_CALL_USED | JIT_REG_IN_STACK}, \
-	{"st2", 2, -1, JIT_REG_X86_FLOAT | JIT_REG_CALL_USED | JIT_REG_IN_STACK}, \
-	{"st3", 3, -1, JIT_REG_X86_FLOAT | JIT_REG_CALL_USED | JIT_REG_IN_STACK}, \
-	{"st4", 4, -1, JIT_REG_X86_FLOAT | JIT_REG_CALL_USED | JIT_REG_IN_STACK}, \
-	{"st5", 5, -1, JIT_REG_X86_FLOAT | JIT_REG_CALL_USED | JIT_REG_IN_STACK}, \
-	{"st6", 6, -1, JIT_REG_X86_FLOAT | JIT_REG_CALL_USED | JIT_REG_IN_STACK}, \
-	{"st7", 7, -1, JIT_REG_X86_FLOAT | JIT_REG_CALL_USED | JIT_REG_IN_STACK},
+	{"eax", NULL, 0, 2, JIT_REG_WORD | JIT_REG_LONG | JIT_REG_CALL_USED}, \
+	{"ecx", NULL, 1, 3, JIT_REG_WORD | JIT_REG_LONG | JIT_REG_CALL_USED}, \
+	{"edx", NULL, 2, -1, JIT_REG_WORD | JIT_REG_CALL_USED}, \
+	{"ebx", NULL, 3, -1, JIT_REG_WORD | JIT_REG_GLOBAL}, \
+	{"esi", NULL, 6, -1, JIT_REG_WORD | JIT_REG_GLOBAL}, \
+	{"edi", NULL, 7, -1, JIT_REG_WORD | JIT_REG_GLOBAL}, \
+	{"ebp", NULL, 4, -1, JIT_REG_FRAME | JIT_REG_FIXED}, \
+	{"esp", NULL, 5, -1, JIT_REG_STACK_PTR | JIT_REG_FIXED | JIT_REG_CALL_USED}, \
+	{"st", NULL,  0, -1, JIT_REG_X86_FLOAT | JIT_REG_CALL_USED | JIT_REG_IN_STACK}, \
+	{"st1", NULL, 1, -1, JIT_REG_X86_FLOAT | JIT_REG_CALL_USED | JIT_REG_IN_STACK}, \
+	{"st2", NULL, 2, -1, JIT_REG_X86_FLOAT | JIT_REG_CALL_USED | JIT_REG_IN_STACK}, \
+	{"st3", NULL, 3, -1, JIT_REG_X86_FLOAT | JIT_REG_CALL_USED | JIT_REG_IN_STACK}, \
+	{"st4", NULL, 4, -1, JIT_REG_X86_FLOAT | JIT_REG_CALL_USED | JIT_REG_IN_STACK}, \
+	{"st5", NULL, 5, -1, JIT_REG_X86_FLOAT | JIT_REG_CALL_USED | JIT_REG_IN_STACK}, \
+	{"st6", NULL, 6, -1, JIT_REG_X86_FLOAT | JIT_REG_CALL_USED | JIT_REG_IN_STACK}, \
+	{"st7", NULL, 7, -1, JIT_REG_X86_FLOAT | JIT_REG_CALL_USED | JIT_REG_IN_STACK},
 #define	JIT_NUM_REGS		16
 #define	JIT_NUM_GLOBAL_REGS	3
 
diff --git a/jit/jit-rules.h b/jit/jit-rules.h
index 3093cdd..904e8d1 100644
--- a/jit/jit-rules.h
+++ b/jit/jit-rules.h
@@ -63,6 +63,7 @@ extern	"C" {
 typedef struct
 {
 	const char		*name;		/* Name of the register, for debugging */
+	const char		*alias;		/* Alias of the register (eg.: "argreg1", "argreg2", etc. */
 	short			cpu_reg;	/* CPU register number */
 	short			other_reg;	/* Other register for a "long" pair, or -1 */
 	int			flags;		/* Flags that define the register type */
@@ -116,6 +117,9 @@ extern jit_reginfo_t const _jit_reg_info[JIT_NUM_REGS];
 /* Get register name. */
 #define jit_reg_name(reg)		(_jit_reg_info[reg].name)
 
+/* Get register alias. */
+#define jit_reg_alias(reg)		(_jit_reg_info[reg].alias)
+
 /* Get register flags. */
 #define jit_reg_flags(reg)		(_jit_reg_info[reg].flags)
 
diff --git a/tools/gen-apply-win64.h b/tools/gen-apply-win64.h
new file mode 100644
index 0000000..473f61c
--- /dev/null
+++ b/tools/gen-apply-win64.h
@@ -0,0 +1,78 @@
+/*
+ * gen-apply-win64.h - Windows X64 definitions.
+ *
+ * Copyright (C) 2004  Southern Storm Software, Pty Ltd.
+ *
+ * This file is part of the libjit library.
+ *
+ * The libjit library is free software: you can redistribute it and/or
+ * modify it under the terms of the GNU Lesser General Public License
+ * as published by the Free Software Foundation, either version 2.1 of
+ * the License, or (at your option) any later version.
+ *
+ * The libjit library is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * Lesser General Public License for more details.
+ *
+ * You should have received a copy of the GNU Lesser General Public
+ * License along with the libjit library.  If not, see
+ * <http://www.gnu.org/licenses/>.
+ */
+
+#ifndef	_GEN_APPLY_WIN64_H
+#define	_GEN_APPLY_WIN64_H
+
+#ifdef	__cplusplus
+extern "C" {
+#endif
+
+#define JIT_APPLY_NUM_WORD_REGS 4
+#define JIT_APPLY_NUM_FLOAT_REGS 4
+#define JIT_APPLY_ARG_REGISTERS_OVERLAP 1
+#define JIT_APPLY_PASS_STACK_FLOAT_AS_DOUBLE 0
+#define JIT_APPLY_PASS_STACK_FLOAT_AS_NFLOAT 0
+#define JIT_APPLY_PASS_STACK_DOUBLE_AS_NFLOAT 0
+#define JIT_APPLY_PASS_STACK_NFLOAT_AS_DOUBLE 0
+#define JIT_APPLY_PASS_REG_FLOAT_AS_DOUBLE 0
+#define JIT_APPLY_PASS_REG_FLOAT_AS_NFLOAT 0
+#define JIT_APPLY_PASS_REG_DOUBLE_AS_NFLOAT 0
+#define JIT_APPLY_PASS_REG_NFLOAT_AS_DOUBLE 0
+#define JIT_APPLY_RETURN_FLOAT_AS_DOUBLE 0
+#define JIT_APPLY_RETURN_FLOAT_AS_NFLOAT 0
+#define JIT_APPLY_RETURN_DOUBLE_AS_NFLOAT 0
+#define JIT_APPLY_RETURN_NFLOAT_AS_DOUBLE 0
+#define JIT_APPLY_FLOATS_IN_WORD_REGS 0
+#define JIT_APPLY_RETURN_FLOATS_AFTER 8
+#define JIT_APPLY_VARARGS_ON_STACK 1
+#define JIT_APPLY_STRUCT_RETURN_SPECIAL_REG 0
+#define JIT_APPLY_STRUCT_REG_OVERLAPS_WORD_REG 0
+#define JIT_APPLY_ALIGN_LONG_REGS 1
+#define JIT_APPLY_ALIGN_LONG_STACK 1
+#define JIT_APPLY_CAN_SPLIT_LONG 0
+#define JIT_APPLY_STRUCT_RETURN_IN_REG \
+	{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, \
+	 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, \
+	 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, \
+	 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}
+#define JIT_APPLY_MAX_STRUCT_IN_REG 0
+#define JIT_APPLY_SPLIT_STRUCT_OVER_REGS 0
+#define JIT_APPLY_X86_FASTCALL 0
+#define JIT_APPLY_PARENT_FRAME_OFFSET 0
+#define JIT_APPLY_RETURN_ADDRESS_OFFSET 0
+#define JIT_APPLY_BROKEN_FRAME_BUILTINS 1
+#define JIT_APPLY_X86_POP_STRUCT_RETURN 0
+#define JIT_APPLY_PAD_FLOAT_REGS 1
+
+#define JIT_APPLY_NUM_DOUBLE_REGS 4
+#define JIT_APPLY_NUM_NFLOAT_REGS 0
+#define JIT_APPLY_DOUBLES_IN_WORD_REGS 0
+#define JIT_APPLY_NFLOATS_IN_WORD_REGS 0
+#define JIT_APPLY_RETURN_DOUBLES_AFTER 0
+#define JIT_APPLY_RETURN_NFLOATS_AFTER 0
+
+#ifdef	__cplusplus
+};
+#endif
+
+#endif	/* _GEN_APPLY_WIN64_H */
diff --git a/tools/gen-apply.c b/tools/gen-apply.c
index 2951802..d1239ed 100644
--- a/tools/gen-apply.c
+++ b/tools/gen-apply.c
@@ -98,7 +98,9 @@ the "jit-apply-rules.h" file.
 #if defined(PLATFORM_IS_MACOSX)
 	#include "gen-apply-macosx.h"
 #endif
-
+#if defined(__MINGW64__)
+	#include "gen-apply-win64.h"
+#endif
 /*
  * Values that are detected.
  */
@@ -107,6 +109,7 @@ int num_word_regs = 0;
 int num_float_regs = 0;
 int num_double_regs = 0;
 int num_nfloat_regs = 0;
+int arg_registers_overlap = 0;
 int pass_stack_float_as_double = 0;
 int pass_stack_float_as_nfloat = 0;
 int pass_stack_double_as_nfloat = 0;
@@ -137,6 +140,7 @@ int parent_frame_offset = 0;
 int return_address_offset = 0;
 int broken_frame_builtins = 0;
 int max_struct_in_reg = 0;
+int split_struct_over_regs = 1;
 int x86_pop_struct_return = 0;
 int pad_float_regs = 0;
 #else
@@ -144,6 +148,7 @@ int num_word_regs = JIT_APPLY_NUM_WORD_REGS;
 int num_float_regs = JIT_APPLY_NUM_FLOAT_REGS;
 int num_double_regs = JIT_APPLY_NUM_DOUBLE_REGS;
 int num_nfloat_regs = JIT_APPLY_NUM_NFLOAT_REGS;
+int arg_registers_overlap = JIT_APPLY_ARG_REGISTERS_OVERLAP;
 int pass_stack_float_as_double = JIT_APPLY_PASS_STACK_FLOAT_AS_DOUBLE;
 int pass_stack_float_as_nfloat = JIT_APPLY_PASS_STACK_FLOAT_AS_NFLOAT;
 int pass_stack_double_as_nfloat = JIT_APPLY_PASS_STACK_DOUBLE_AS_NFLOAT;
@@ -174,6 +179,7 @@ int parent_frame_offset = JIT_APPLY_PARENT_FRAME_OFFSET;
 int return_address_offset = JIT_APPLY_RETURN_ADDRESS_OFFSET;
 int broken_frame_builtins = JIT_APPLY_BROKEN_FRAME_BUILTINS;
 int max_struct_in_reg = JIT_APPLY_MAX_STRUCT_IN_REG;
+int split_struct_over_regs = JIT_APPLY_SPLIT_STRUCT_OVER_REGS;
 int x86_pop_struct_return = JIT_APPLY_X86_POP_STRUCT_RETURN;
 int pad_float_regs = JIT_APPLY_PAD_FLOAT_REGS;
 #endif
@@ -1868,6 +1874,10 @@ void dump_apply_macros(void)
 		printf("\t\t{ \\\n");
 		printf("\t\t\t(builder)->apply_args->word_regs[(builder)->word_used] = (jit_nint)(value); \\\n");
 		printf("\t\t\t++((builder)->word_used); \\\n");
+		if (arg_registers_overlap && num_float_regs > 0)
+		{
+			printf("\t\t\t++((builder)->float_used); \\\n");
+		}
 		if(struct_reg_overlaps_word_reg)
 		{
 			/* We need to set the struct register slot as well */
@@ -1899,6 +1909,10 @@ void dump_apply_macros(void)
 		printf("\t\t{ \\\n");
 		printf("\t\t\t(value) = (type)((builder)->apply_args->word_regs[(builder)->word_used]); \\\n");
 		printf("\t\t\t++((builder)->word_used); \\\n");
+		if (arg_registers_overlap && num_float_regs > 0)
+		{
+			printf("\t\t\t++((builder)->float_used); \\\n");
+		}
 		printf("\t\t} \\\n");
 		printf("\t\telse \\\n");
 		printf("\t\t{ \\\n");
@@ -1926,6 +1940,10 @@ void dump_apply_macros(void)
 			printf("\t\t\tif(((builder)->word_used %% 2) == 1) \\\n");
 			printf("\t\t\t{ \\\n");
 			printf("\t\t\t\t++((builder)->word_used); \\\n");
+			if (arg_registers_overlap && num_float_regs > 0)
+			{
+				printf("\t\t\t\t++((builder)->float_used); \\\n");
+			}
 			printf("\t\t\t} \\\n");
 		}
 		if(!can_split_long)
@@ -1933,6 +1951,10 @@ void dump_apply_macros(void)
 			printf("\t\t\tif((%s - (builder)->word_used) < (num_words)) \\\n", word_reg_limit);
 			printf("\t\t\t{ \\\n");
 			printf("\t\t\t\t(builder)->word_used = %s; \\\n", word_reg_limit);
+			if (arg_registers_overlap && num_float_regs > 0)
+			{
+				printf("\t\t\t\t(builder)->float_used = %s; \\\n", word_reg_limit);
+			}
 			printf("\t\t\t} \\\n");
 		}
 		printf("\t\t} \\\n");
@@ -1973,6 +1995,10 @@ void dump_apply_macros(void)
 		printf("\t\t{ \\\n");
 		printf("\t\t\tjit_memcpy((builder)->apply_args->word_regs + (builder)->word_used, (ptr), (size)); \\\n");
 		printf("\t\t\t(builder)->word_used += __num_words; \\\n");
+		if (arg_registers_overlap && num_float_regs > 0)
+		{
+			printf("\t\t\t(builder)->float_used = (builder)->word_used; \\\n");
+		}
 		printf("\t\t} \\\n");
 		printf("\t\telse if((builder)->word_used < %s) \\\n", word_reg_limit);
 		printf("\t\t{ \\\n");
@@ -1980,6 +2006,10 @@ void dump_apply_macros(void)
 		printf("\t\t\tjit_memcpy((builder)->apply_args->word_regs + (builder)->word_used, (ptr), __split * sizeof(jit_nint)); \\\n");
 		printf("\t\t\tjit_memcpy((builder)->apply_args->stack_args, ((jit_nint *)(ptr)) + __split, (size) - __split * sizeof(jit_nint)); \\\n");
 		printf("\t\t\t(builder)->word_used = %s; \\\n", word_reg_limit);
+		if (arg_registers_overlap && num_float_regs > 0)
+		{
+			printf("\t\t\t(builder)->float_used = %s; \\\n", word_reg_limit);
+		}
 		printf("\t\t\t(builder)->stack_used = __num_words - __split; \\\n");
 		printf("\t\t} \\\n");
 		printf("\t\telse \\\n");
@@ -1988,6 +2018,10 @@ void dump_apply_macros(void)
 		printf("\t\t\tjit_memcpy((builder)->apply_args->stack_args + (builder)->stack_used, (ptr), (size)); \\\n");
 		printf("\t\t\t(builder)->stack_used += __num_words * sizeof(jit_nint); \\\n");
 		printf("\t\t\t(builder)->word_used = %s; \\\n", word_reg_limit);
+		if (arg_registers_overlap && num_float_regs > 0)
+		{
+			printf("\t\t\t(builder)->float_used = %s; \\\n", word_reg_limit);
+		}
 		printf("\t\t} \\\n");
 	}
 	else
@@ -2022,6 +2056,10 @@ void dump_apply_macros(void)
 		printf("\t\t\tjit_memcpy(&__temp, (builder)->apply_args->word_regs + (builder)->word_used, __split * sizeof(jit_nint)); \\\n");
 		printf("\t\t\tjit_memcpy(((jit_nint *)&__temp) + __split, (builder)->apply_args->stack_args, (__num_words - __split) * sizeof(jit_nint)); \\\n");
 		printf("\t\t\t(builder)->word_used = %s; \\\n", word_reg_limit);
+		if (arg_registers_overlap && num_float_regs > 0)
+		{
+			printf("\t\t\t(builder)->float_used = %s; \\\n", word_reg_limit);
+		}
 		printf("\t\t\t(builder)->stack_used = __num_words - __split; \\\n");
 		printf("\t\t} \\\n");
 		printf("\t\telse \\\n");
@@ -2030,6 +2068,10 @@ void dump_apply_macros(void)
 		printf("\t\t\tjit_memcpy(&__temp, (builder)->apply_args->stack_args + (builder)->stack_used, sizeof(__temp)); \\\n");
 		printf("\t\t\t(builder)->stack_used += __num_words * sizeof(jit_nint); \\\n");
 		printf("\t\t\t(builder)->word_used = %s; \\\n", word_reg_limit);
+		if (arg_registers_overlap && num_float_regs > 0)
+		{
+			printf("\t\t\t(builder)->float_used = %s; \\\n", word_reg_limit);
+		}
 		printf("\t\t} \\\n");
 	}
 	else
@@ -2173,6 +2215,10 @@ void dump_apply_macros(void)
 		printf("\t\t{ \\\n");
 		printf("\t\t\t(builder)->apply_args->float_regs[(builder)->float_used].float_value = (jit_reg_float)(value); \\\n");
 		printf("\t\t\t++((builder)->float_used); \\\n");
+		if (arg_registers_overlap && num_word_regs > 0)
+		{
+			printf("\t\t\t++((builder)->word_used); \\\n");
+		}
 		printf("\t\t} \\\n");
 		printf("\t\telse \\\n");
 		printf("\t\t{ \\\n");
@@ -2220,6 +2266,10 @@ void dump_apply_macros(void)
 		printf("\t\t{ \\\n");
 		printf("\t\t\t(builder)->apply_args->float_regs[(builder)->float_used].double_value = (jit_reg_double)(value); \\\n");
 		printf("\t\t\t++((builder)->float_used); \\\n");
+		if (arg_registers_overlap && num_word_regs > 0)
+		{
+			printf("\t\t\t++((builder)->word_used); \\\n");
+		}
 		printf("\t\t} \\\n");
 		printf("\t\telse \\\n");
 		if(pass_stack_double_as_nfloat)
@@ -2261,6 +2311,10 @@ void dump_apply_macros(void)
 		printf("\t\t{ \\\n");
 		printf("\t\t\t(builder)->apply_args->float_regs[(builder)->float_used].nfloat_value = (jit_reg_nfloat)(value); \\\n");
 		printf("\t\t\t++((builder)->float_used); \\\n");
+		if (arg_registers_overlap && num_word_regs > 0)
+		{
+			printf("\t\t\t++((builder)->word_used); \\\n");
+		}
 		printf("\t\t} \\\n");
 		printf("\t\telse \\\n");
 		if(pass_stack_nfloat_as_double)
@@ -2340,6 +2394,10 @@ void dump_apply_macros(void)
 		printf("\t\t{ \\\n");
 		printf("\t\t\t(value) = (jit_float32)((builder)->apply_args->float_regs[(builder)->float_used].float_value); \\\n");
 		printf("\t\t\t++((builder)->float_used); \\\n");
+		if (arg_registers_overlap && num_word_regs > 0)
+		{
+			printf("\t\t\t++((builder)->word_used); \\\n");
+		}
 		printf("\t\t} \\\n");
 		printf("\t\telse \\\n");
 		printf("\t\t{ \\\n");
@@ -2389,6 +2447,10 @@ void dump_apply_macros(void)
 		printf("\t\t{ \\\n");
 		printf("\t\t\t(value) = (jit_float64)((builder)->apply_args->float_regs[(builder)->float_used].double_value); \\\n");
 		printf("\t\t\t++((builder)->float_used); \\\n");
+		if (arg_registers_overlap && num_word_regs > 0)
+		{
+			printf("\t\t\t++((builder)->word_used); \\\n");
+		}
 		printf("\t\t} \\\n");
 		printf("\t\telse \\\n");
 		if(pass_stack_double_as_nfloat)
@@ -2432,6 +2494,10 @@ void dump_apply_macros(void)
 		printf("\t\t{ \\\n");
 		printf("\t\t\t(value) = (jit_nfloat)((builder)->apply_args->float_regs[(builder)->float_used].nfloat_value); \\\n");
 		printf("\t\t\t++((builder)->float_used); \\\n");
+		if (arg_registers_overlap && num_word_regs > 0)
+		{
+			printf("\t\t\t++((builder)->word_used); \\\n");
+		}
 		printf("\t\t} \\\n");
 		printf("\t\telse \\\n");
 		if(pass_stack_nfloat_as_double)
@@ -2494,6 +2560,10 @@ void dump_apply_macros(void)
 		printf("\t\t\t(builder)->stack_used += __num_words * sizeof(jit_nint); \\\n");
 		printf("\t\t\t(builder)->word_used = %s; \\\n", word_reg_limit);
 		printf("\t\t} \\\n");
+		if (arg_registers_overlap && num_float_regs > 0)
+		{
+			printf("\t\t(builder)->float_used = (builder)->word_used; \\\n");
+		}
 	}
 	else
 	{
@@ -2636,6 +2706,7 @@ int main(int argc, char *argv[])
 	printf("#define JIT_APPLY_NUM_FLOAT_REGS %d\n", num_float_regs);
 	printf("#define JIT_APPLY_NUM_DOUBLE_REGS %d\n", num_double_regs);
 	printf("#define JIT_APPLY_NUM_NFLOAT_REGS %d\n", num_nfloat_regs);
+	printf("#define JIT_APPLY_ARG_REGISTERS_OVERLAP %d\n", arg_registers_overlap);
 	printf("#define JIT_APPLY_PASS_STACK_FLOAT_AS_DOUBLE %d\n",
 		   pass_stack_float_as_double);
 	printf("#define JIT_APPLY_PASS_STACK_FLOAT_AS_NFLOAT %d\n",
@@ -2725,6 +2796,7 @@ int main(int argc, char *argv[])
 	}
 	printf("}\n");
 	printf("#define JIT_APPLY_MAX_STRUCT_IN_REG %d\n", max_struct_in_reg);
+	printf("#define JIT_APPLY_SPLIT_STRUCT_OVER_REGS %d\n", split_struct_over_regs);
 	printf("#define JIT_APPLY_MAX_APPLY_SIZE %d\n", max_apply_size);
 	printf("#define JIT_APPLY_X86_FASTCALL %d\n", x86_fastcall);
 	printf("#define JIT_APPLY_PARENT_FRAME_OFFSET %d\n", parent_frame_offset);
